#ifndef __CMD_H__
#define __CMD_H__ 1
/* 
   elmo - ELectronic Mail Operator

   Copyright (C) 2002, 2003 rzyjontko

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  

*/
/*****************************************************************************
 *    INTERFACE REQUIRED HEADERS
 ****************************************************************************/

#include "ecurses.h"
#include "keymap.h"
#include "hook.h"

/*****************************************************************************
 *    INTERFACE DEFINITIONS / ENUMERATIONS / SIMPLE TYPEDEFS
 ****************************************************************************/

typedef enum {CMD_INVALID,
              CMD_LIST,
              CMD_READ_MAIL,
              CMD_SELECT_BOX,
              CMD_FETCH,
              CMD_SENDER,
              CMD_ATTACH,
              CMD_ABOOK,
              CMD_ABOOK_ADD,
              CMD_ASK,
              CMD_HELP,
} cmd_state_t;

#define CMD_STATE_COUNT (CMD_HELP + 1)

/****************************************************************************
 *    INTERFACE CLASS PROTOTYPES / EXTERNAL CLASS REFERENCES
 ****************************************************************************/
/****************************************************************************
 *    INTERFACE STRUCTURES / UTILITY CLASSES
 ****************************************************************************/
/****************************************************************************
 *    INTERFACE DATA DECLARATIONS
 ****************************************************************************/

extern WINDOW *cmd_echo_area;

extern keymap_t keymaps[];
extern hook_t   state_back_hooks[];
extern hook_t   state_leave_hooks[];

/****************************************************************************
 *    INTERFACE FUNCTION PROTOTYPES
 ****************************************************************************/

extern void        cmd_init (void);
extern void        cmd_quit (void);
extern void        cmd_read_loop (void);
extern void        cmd_state_push (cmd_state_t requested_state);
extern void        cmd_state_pop (void);
extern cmd_state_t cmd_state_get (void);
extern void        cmd_refresh (void);
extern void        cmd_choose (void);
extern void        cmd_test_action (void);

/****************************************************************************
 *    INTERFACE OBJECT CLASS DEFINITIONS
 ****************************************************************************/
/****************************************************************************
 *    INTERFACE TRAILING HEADERS
 ****************************************************************************/
/****************************************************************************
 *
 *    END HEADER cmd.h
 *
 ****************************************************************************/
#endif
