/* 
   elmo - ELectronic Mail Operator

   Copyright (C) 2002 rzyjontko

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  

   ----------------------------------------------------------------------

   some miscelaneous functions used only for checking purposes
   
*/
/****************************************************************************
 *    IMPLEMENTATION HEADERS
 ****************************************************************************/

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#include <time.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "xmalloc.h"

/****************************************************************************
 *    IMPLEMENTATION PRIVATE DEFINITIONS / ENUMERATIONS / SIMPLE TYPEDEFS
 ****************************************************************************/
/****************************************************************************
 *    IMPLEMENTATION PRIVATE CLASS PROTOTYPES / EXTERNAL CLASS REFERENCES
 ****************************************************************************/
/****************************************************************************
 *    IMPLEMENTATION PRIVATE STRUCTURES / UTILITY CLASSES
 ****************************************************************************/
/****************************************************************************
 *    IMPLEMENTATION REQUIRED EXTERNAL REFERENCES (AVOID)
 ****************************************************************************/
/****************************************************************************
 *    IMPLEMENTATION PRIVATE DATA
 ****************************************************************************/
/****************************************************************************
 *    INTERFACE DATA
 ****************************************************************************/
/****************************************************************************
 *    IMPLEMENTATION PRIVATE FUNCTION PROTOTYPES
 ****************************************************************************/
/****************************************************************************
 *    IMPLEMENTATION PRIVATE FUNCTIONS
 ****************************************************************************/
/****************************************************************************
 *    INTERFACE FUNCTIONS
 ****************************************************************************/

#ifndef HAVE_STPCPY

char *
stpcpy (char *dest, const char *src)
{
  int len = strlen (src);

  memcpy (dest, src, len + 1);
  return dest + len;
}

#endif


char *
human_size_pure (int size)
{
  static char hsize[40];

  if (size >= 1024 * 1024 * 512){
    snprintf (hsize, sizeof (hsize), "%d.%dG",
              size / (1024 * 1024 * 1024),
              size % (1024 * 1024 * 1024) * 10 / (1024 * 1024 * 1024));
  }
  else if (size >= 1024 * 512){
    snprintf (hsize, sizeof (hsize), "%d.%dM", size / (1024 * 1024),
              size % (1024 * 1024) * 10 / (1024 * 1024));
  }
  else if (size >= 512){
    snprintf (hsize, sizeof (hsize), "%d.%dK", size / 1024,
              size % 1024 * 10 / 1024);
  }
  else {
    snprintf (hsize, sizeof (hsize), "%d", size);
  }
  return hsize;
}


char *
human_size_paren (int size)
{
  static char hsize[40];
  int         ret;

  ret = snprintf (hsize, sizeof (hsize), "(%s)", human_size_pure (size));
  
  while (ret < 8){
    hsize[ret] = ' ';
    ret++;
  }
  hsize[ret] = '\0';
  return hsize;
}



char *
date_string (const char *format, time_t tm)
{
  static char  time_s[80];
  char        *result;
  int          len;
  struct tm   *loctime;

  loctime = localtime (&tm);
  len     = strftime (time_s, sizeof (time_s), format, loctime);
  result  = xmalloc (6 + len + 1);
  memcpy (result, time_s, len + 1);

  return result;
}


/****************************************************************************
 *    INTERFACE CLASS BODIES
 ****************************************************************************/
/****************************************************************************
 *
 *    END MODULE misc.c
 *
 ****************************************************************************/
